using System;
using System.Collections.Generic;
using System.Text;
using NeoTicker;

namespace MovingAverageCrossSys
{
    [System.Security.SuppressUnmanagedCodeSecurity]
    public class MainIDL : IIDLIndicator
    {

        #region IIDLIndicator Members

        double IIDLIndicator.IDLCallEx(NTIndicatorObjects NTIndicatorObjects)
        {

            IItselfObj ItSelf = NTIndicatorObjects.ItSelf();
            TradeObj Trade = NTIndicatorObjects.Trade();
            
            INestedIndicatorObj fma = ItSelf.UpdateIndicatorEx(1);
            if (fma == null)
            {
                IParamObj Param1 = NTIndicatorObjects.Param1();
                string fperiod = (string)Param1.Str;

                fma = ItSelf.MakeIndicatorEx(
                           "fma", 1,
                           "average",
                           new string[] { "1" },
                           new string[] { fperiod });
            }

            INestedIndicatorObj sma = ItSelf.UpdateIndicatorEx(2);
            if (sma == null)
            {
                IParamObj Param2 = NTIndicatorObjects.Param2();
                string speriod = (string)Param2.Str;

                sma = ItSelf.MakeIndicatorEx(
                            "sma", 2,
                            "average",
                            new string[] { "1" },
                            new string[] { speriod });
            }

            INestedIndicatorObj xover = ItSelf.UpdateIndicatorEx(3);
            if (xover == null)
            {
                xover = ItSelf.MakeIndicatorEx(
                            "xo", 3,
                            "xcross",
                            new string[] { "fma", "sma" },
                            new string[] { " " });
            }

            if (xover.get_Valid(0))
            {
                if (xover.get_Value(0) > 0)
                {
                    Trade.LongAtMarket(Trade.DefaultOrderSize, "long cross above");
                }

                if (xover.get_Value(0) < 0)
                {
                    Trade.ShortAtMarket(Trade.DefaultOrderSize, "short cross below");
                }

                ItSelf.set_Plot(1, xover.get_Value(0));
                ItSelf.set_Plot(2, Trade.CurrentEquity);
            }
            else
            {
                ItSelf.Success = false;
            }

            return 0;
        }

        #endregion
    }
}
